Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 4333)
@@ -292,6 +292,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   dh_i_surf2D, dh_i_bott2D, fstbif, fsup2D, focea2D, q_s
 
-   INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   patho_case ! number of the pathological case (if any, of course)
-
    !!--------------------------------------------------------------------------
    !! * Ice global state variables
@@ -465,7 +463,4 @@
          &      fsup2D     (jpi,jpj) , focea2D    (jpi,jpj) , q_s   (jpi,jpj) , STAT=ierr(ii) )
 
-      ii = ii + 1
-      ALLOCATE( patho_case(jpi, jpj, jpl)  , STAT=ierr(ii) )
-
       ! * Ice global state variables
       ii = ii + 1
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 4333)
@@ -90,5 +90,5 @@
       !
       !                                ! Initial sea-ice state
-      IF( .NOT.ln_rstart ) THEN              ! start from rest
+      IF( .NOT. ln_rstart ) THEN              ! start from rest
          numit = 0
          numit = nit000 - 1
@@ -105,8 +105,8 @@
       hi_max(jpl) = 99._wp  ! Set hi_max(jpl) to a big value to ensure that all ice is thinner than hi_max(jpl)
       !
-      CALL lim_sbc_init                ! ice surface boundary condition   
-      !
-      fr_i(:,:) = at_i(:,:)           ! initialisation of sea-ice fraction
-      tn_ice(:,:,:) = t_su(:,:,:)
+      CALL lim_sbc_init                 ! ice surface boundary condition   
+      !
+      fr_i(:,:) = at_i(:,:)             ! initialisation of sea-ice fraction
+      tn_ice(:,:,:) = t_su(:,:,:)       ! initialisation of surface temp for coupled simu
       !
       nstart = numit  + nn_fsbc      
@@ -143,8 +143,8 @@
       WRITE ( numoni, namicerun )
       !
-      IF( lk_mpp .AND. ln_nicep ) THEN
-         ln_nicep = .FALSE.
-         CALL ctl_warn( 'ice_run : specific control print for LIM3 desactivated with MPI' )
-      ENDIF
+      !IF( lk_mpp .AND. ln_nicep ) THEN
+      !   ln_nicep = .FALSE.
+      !   CALL ctl_warn( 'ice_run : specific control print for LIM3 desactivated with MPI' )
+      !ENDIF
       !
       IF(lwp) THEN                        ! control print
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90	(revision 4333)
@@ -45,5 +45,5 @@
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   zht_i, zht_s, za_i ! output ice/snow variables
       REAL(wp) :: epsi06 = 1.0e-6
-      REAL(wp) ::   zc1, zc2, zc3, zx1   ! local scalars
+      REAL(wp) :: zc1, zc2, zc3, zx1, zdh   ! local scalars
       REAL(wp), DIMENSION(0:jpl)   ::   zhi_max         !:Boundary of ice thickness categories in thickness space
  
@@ -85,7 +85,7 @@
       ! ----------------------------------------
       DO ji = 1, ijpij
-        ! snow thickness in each category 
-         zht_s(ji,1:jpl) = zhts(ji)
          
+         IF( zhti(ji) > 0._wp ) THEN
+
          ! initialisation of tests
          ztest_1 = 0
@@ -108,5 +108,4 @@
                zht_i(ji,1) = zhti(ji)
                za_i (ji,1) = zai (ji)
-               
                ! *** case ice is thicker: fill categories >1
             ELSE
@@ -178,6 +177,25 @@
          !   WRITE(numout,*) 'za_i(ji,jpl)=',za_i(ji,:)
          !ENDIF
-            
+         
+         ENDIF ! if zhti > 0
+
       END DO ! i loop
+
+      ! ------------------------------------------------
+      ! Adding Snow in each category where za_i is not 0
+      ! ------------------------------------------------ 
+      DO jl = 1, jpl
+         DO ji = 1, ijpij
+            IF( za_i(ji,jl) > 0._wp ) THEN
+               zht_s(ji,jl) = zht_i(ji,jl) * ( zhts(ji) / zhti(ji) )
+               ! In case snow load is in excess that would lead to transformation from snow to ice
+               ! Then, transfer the snow excess into the ice (different from limthd_dh)
+               zdh = MAX( 0._wp, ( rhosn * zht_s(ji,jl) + ( rhoic - rau0 ) * zht_i(ji,jl) ) * r1_rau0 ) 
+               ! recompute ht_i, ht_s avoiding out of bounds values
+               zht_i(ji,jl) = MIN( zhi_max(jl), zht_i(ji,jl) + zdh )
+               zht_s(ji,jl) = MAX( 0._wp, zht_s(ji,jl) - zdh * rhoic / rhosn )
+            ENDIF
+         ENDDO
+      ENDDO
 
       IF( nn_timing == 1 )  CALL timing_stop('limcat_1D')
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 4333)
@@ -29,5 +29,5 @@
 
    LOGICAL  ::   linit = .TRUE.              ! initialization flag (set to flase after the 1st call)
-   REAL(wp) ::   epsi04 = 1e-04              ! constant
+   REAL(wp) ::   epsi04 = 1.e-04              ! constant
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   efact   ! metric coefficient
 
@@ -54,7 +54,7 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   ptab    ! Field on which the diffusion is applied
       !
-      INTEGER  ::  ji, jj            ! dummy loop indices
-      INTEGER  ::  its, iter, ierr   ! local integers
-      REAL(wp) ::   zalfa, zrlxint, zconv, zeps   ! local scalars
+      INTEGER  ::  ji, jj                   ! dummy loop indices
+      INTEGER  ::  its, iter, ierr          ! local integers
+      REAL(wp) ::   zalfa, zrlxint, zconv   ! local scalars
       REAL(wp), POINTER, DIMENSION(:,:) ::   zrlx, zflu, zflv, zdiv0, zdiv, ztab0
       CHARACTER(lc) ::   charout   ! local character
@@ -79,5 +79,4 @@
       zalfa = 0.5_wp                      ! =1.0/0.5/0.0 = implicit/Cranck-Nicholson/explicit
       its   = 100                         ! Maximum number of iteration
-      zeps  =  2._wp * epsi04
       !
       ztab0(:, : ) = ptab(:,:)      ! Arrays initialization
@@ -94,5 +93,5 @@
       iter  = 0
       !
-      DO WHILE( zconv > zeps .AND. iter <= its )   ! Sub-time step loop
+      DO WHILE( zconv > ( 2._wp * epsi04 ) .AND. iter <= its )   ! Sub-time step loop
          !
          iter = iter + 1                                 ! incrementation of the sub-time step number
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4333)
@@ -76,4 +76,7 @@
       !!                6) Lateral boundary conditions
       !!
+      !! ** Notes   : o_i, t_su, t_s, t_i, s_i must be filled everywhere, even
+      !!              where there is no ice (clem: I do not know why but it is mandatory) 
+      !!
       !! History :
       !!   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
@@ -84,5 +87,5 @@
       !! * Local variables
       INTEGER    :: ji, jj, jk, jl             ! dummy loop indices
-      REAL(wp)   :: epsi06, epsi20, ztmelts
+      REAL(wp)   :: epsi20, ztmelts, zdh
       INTEGER    :: i_hemis, i_fill, jl0  
       REAL(wp)   :: ztest_1, ztest_2, ztest_3, ztest_4, ztests, zsigma, zarg, zA, zV, zA_cons, zV_cons, zconv
@@ -98,5 +101,4 @@
       CALL wrk_alloc(   2,      zhm_i_ini, zat_i_ini, zvt_i_ini, zhm_s_ini, zsm_i_ini )
 
-      epsi06   = 1.0e-6
       epsi20   = 1.0e-20
       IF(lwp) WRITE(numout,*)
@@ -308,6 +310,5 @@
       !---------------------------------------------------------------------
 
-      ! Ice concentration, thickness and volume, snow depth, ice
-      ! salinity, ice age, surface temperature
+      ! Ice concentration, thickness and volume, ice salinity, ice age, surface temperature
       DO jl = 1, jpl ! loop over categories
          DO jj = 1, jpj
@@ -315,10 +316,18 @@
                a_i(ji,jj,jl)   = zidto(ji,jj) * za_i_ini (jl,zhemis(ji,jj))  ! concentration
                ht_i(ji,jj,jl)  = zidto(ji,jj) * zht_i_ini(jl,zhemis(ji,jj))  ! ice thickness
-               ht_s(ji,jj,jl)  = zidto(ji,jj) * zhm_s_ini(zhemis(ji,jj))     ! snow depth
-               sm_i(ji,jj,jl)  = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj))     ! salinity
+               ht_s(ji,jj,jl)  = ht_i(ji,jj,jl) * ( zhm_s_ini( zhemis(ji,jj) ) / zhm_i_ini( zhemis(ji,jj) ) )  ! snow depth
+               sm_i(ji,jj,jl)  = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj)) + ( 1._wp - zidto(ji,jj) ) * s_i_min ! salinity
                o_i(ji,jj,jl)   = zidto(ji,jj) * 1._wp + ( 1._wp - zidto(ji,jj) ) ! age
-               t_su(ji,jj,jl)  = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * t_bo(ji,jj) ! surf temp
- 
-               ! ice volume, snow volume, salt content, age content
+               t_su(ji,jj,jl)  = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * 270.0 ! surf temp
+
+               ! This case below should not be used if (ht_s/ht_i) is ok in namelist
+               ! In case snow load is in excess that would lead to transformation from snow to ice
+               ! Then, transfer the snow excess into the ice (different from limthd_dh)
+               zdh = MAX( 0._wp, ( rhosn * ht_s(ji,jj,jl) + ( rhoic - rau0 ) * ht_i(ji,jj,jl) ) * r1_rau0 ) 
+               ! recompute ht_i, ht_s avoiding out of bounds values
+               ht_i(ji,jj,jl) = MIN( hi_max(jl), ht_i(ji,jj,jl) + zdh )
+               ht_s(ji,jj,jl) = MAX( 0._wp, ht_s(ji,jj,jl) - zdh * rhoic / rhosn )
+
+               ! ice volume, salt content, age content
                v_i(ji,jj,jl)   = ht_i(ji,jj,jl) * a_i(ji,jj,jl)              ! ice volume
                v_s(ji,jj,jl)   = ht_s(ji,jj,jl) * a_i(ji,jj,jl)              ! snow volume
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 4333)
@@ -43,5 +43,5 @@
    PUBLIC   lim_itd_me_alloc        ! called by iceini.F90
 
-   REAL(wp) ::   epsi11 = 1.e-11_wp   ! constant values
+   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
    REAL(wp) ::   epsi10 = 1.e-10_wp   ! constant values
    REAL(wp) ::   epsi06 = 1.e-06_wp   ! constant values
@@ -50,20 +50,18 @@
    ! Variables shared among ridging subroutines
    !-----------------------------------------------------------------------
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
-   !
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
-   !                                                           !  closing associated w/ category n
-   !
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hraft    ! thickness of rafted ice
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   krdg     ! mean ridge thickness/thickness of ridging ice 
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   aridge   ! participating ice ridging
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   araft    ! participating ice rafting
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
+   !                                                     ! closing associated w/ category n
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hraft    ! thickness of rafted ice
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   krdg     ! mean ridge thickness/thickness of ridging ice 
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   aridge   ! participating ice ridging
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   araft    ! participating ice rafting
 
    REAL(wp), PARAMETER ::   krdgmin = 1.1_wp    ! min ridge thickness multiplier
    REAL(wp), PARAMETER ::   kraft   = 2.0_wp    ! rafting multipliyer
-   REAL(wp), PARAMETER ::   kamax   = 1.0
+   REAL(wp), PARAMETER ::   kamax   = 1.0_wp    ! max of ice area authorized (clem: scheme is not stable if kamax <= 0.99)
 
    REAL(wp) ::   Cp                             ! 
@@ -261,5 +259,5 @@
                ! Reduce the closing rate if more than 100% of the open water 
                ! would be removed.  Reduce the opening rate proportionately.
-               IF ( ato_i(ji,jj) .GT. epsi11 .AND. athorn(ji,jj,0) .GT. 0.0 ) THEN
+               IF ( ato_i(ji,jj) .GT. epsi10 .AND. athorn(ji,jj,0) .GT. 0.0 ) THEN
                   w1 = athorn(ji,jj,0) * closing_gross(ji,jj) * rdt_ice
                   IF ( w1 .GT. ato_i(ji,jj)) THEN
@@ -281,5 +279,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  IF ( a_i(ji,jj,jl) > epsi11 .AND. athorn(ji,jj,jl) > 0._wp )THEN
+                  IF ( a_i(ji,jj,jl) > epsi10 .AND. athorn(ji,jj,jl) > 0._wp )THEN
                      w1 = athorn(ji,jj,jl) * closing_gross(ji,jj) * rdt_ice
                      IF ( w1  >  a_i(ji,jj,jl) ) THEN
@@ -312,5 +310,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF (ABS(asum(ji,jj) - kamax ) .LT. epsi11) THEN
+               IF (ABS(asum(ji,jj) - kamax ) .LT. epsi10) THEN
                   closing_net(ji,jj) = 0._wp
                   opning     (ji,jj) = 0._wp
@@ -354,5 +352,5 @@
          DO ji = 1, jpi
 
-            IF(ABS(asum(ji,jj) - kamax) > epsi11 ) asum_error = .true.
+            IF(ABS(asum(ji,jj) - kamax) > epsi10 ) asum_error = .true.
 
             dardg1dt(ji,jj) = dardg1dt(ji,jj) * r1_rdtice
@@ -373,5 +371,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ABS( asum(ji,jj) - kamax)  >  epsi11 ) THEN   ! there is a bug
+            IF( ABS( asum(ji,jj) - kamax)  >  epsi10 ) THEN   ! there is a bug
                WRITE(numout,*) ' '
                WRITE(numout,*) ' ALERTE : Ridging error: total area = ', asum(ji,jj)
@@ -396,7 +394,6 @@
 
       !-----------------------------------------------------------------------------!
-      ! 6) Updating state variables and trend terms
+      ! 6) Updating state variables and trend terms (done in limupdate)
       !-----------------------------------------------------------------------------!
-
       CALL lim_var_glo2eqv
       CALL lim_itd_me_zapsmall
@@ -415,19 +412,4 @@
          END DO
       END DO
-
-      !-----------------
-      !  Trend terms
-      !-----------------
-
-      d_u_ice_dyn(:,:)     = u_ice(:,:)     - old_u_ice(:,:)
-      d_v_ice_dyn(:,:)     = v_ice(:,:)     - old_v_ice(:,:)
-      d_a_i_trp  (:,:,:)   = a_i  (:,:,:)   - old_a_i  (:,:,:)
-      d_v_s_trp  (:,:,:)   = v_s  (:,:,:)   - old_v_s  (:,:,:)  
-      d_v_i_trp  (:,:,:)   = v_i  (:,:,:)   - old_v_i  (:,:,:)   
-      d_e_s_trp  (:,:,:,:) = e_s  (:,:,:,:) - old_e_s  (:,:,:,:)  
-      d_e_i_trp  (:,:,:,:) = e_i  (:,:,:,:) - old_e_i  (:,:,:,:)
-      d_oa_i_trp (:,:,:)   = oa_i (:,:,:)   - old_oa_i (:,:,:)
-      d_smv_i_trp(:,:,:)   = 0._wp
-      IF(  num_sal == 2  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN     ! Control print
@@ -487,64 +469,4 @@
       ! -------------------------------
 
-      !-------------------------!
-      ! Back to initial values
-      !-------------------------!
-
-      ! update of fields will be made later in lim update
-      u_ice(:,:)   = old_u_ice(:,:)
-      v_ice(:,:)   = old_v_ice(:,:)
-      a_i(:,:,:)   = old_a_i(:,:,:)
-      v_s(:,:,:)   = old_v_s(:,:,:)
-      v_i(:,:,:)   = old_v_i(:,:,:)
-      e_s(:,:,:,:) = old_e_s(:,:,:,:)
-      e_i(:,:,:,:) = old_e_i(:,:,:,:)
-      oa_i(:,:,:)  = old_oa_i(:,:,:)
-      IF(  num_sal == 2  )   smv_i(:,:,:) = old_smv_i(:,:,:)
-
-      !----------------------------------------------------!
-      ! Advection of ice in a free cell, newly ridged ice
-      !----------------------------------------------------!
-
-      ! to allow for thermodynamics to melt new ice
-      ! we immediately advect ice in free cells
-
-      ! heat content has to be corrected before ice volume
-!clem@order
-!      DO jl = 1, jpl
-!         DO jk = 1, nlay_i
-!            DO jj = 1, jpj
-!               DO ji = 1, jpi
-!                  IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-!                     ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-!                     old_e_i(ji,jj,jk,jl)   = d_e_i_trp(ji,jj,jk,jl)
-!                     d_e_i_trp(ji,jj,jk,jl) = 0._wp
-!                  ENDIF
-!               END DO
-!            END DO
-!         END DO
-!      END DO
-!
-!      DO jl = 1, jpl
-!         DO jj = 1, jpj
-!            DO ji = 1, jpi
-!               IF(  old_v_i  (ji,jj,jl) < epsi06  .AND. &
-!                    d_v_i_trp(ji,jj,jl) > epsi06    ) THEN
-!                  old_v_i   (ji,jj,jl)   = d_v_i_trp(ji,jj,jl)
-!                  d_v_i_trp (ji,jj,jl)   = 0._wp
-!                  old_a_i   (ji,jj,jl)   = d_a_i_trp(ji,jj,jl)
-!                  d_a_i_trp (ji,jj,jl)   = 0._wp
-!                  old_v_s   (ji,jj,jl)   = d_v_s_trp(ji,jj,jl)
-!                  d_v_s_trp (ji,jj,jl)   = 0._wp
-!                  old_e_s   (ji,jj,1,jl) = d_e_s_trp(ji,jj,1,jl)
-!                  d_e_s_trp (ji,jj,1,jl) = 0._wp
-!                  old_oa_i  (ji,jj,jl)   = d_oa_i_trp(ji,jj,jl)
-!                  d_oa_i_trp(ji,jj,jl)   = 0._wp
-!                  IF(  num_sal == 2  )   old_smv_i(ji,jj,jl) = d_smv_i_trp(ji,jj,jl)
-!                  d_smv_i_trp(ji,jj,jl)  = 0._wp
-!               ENDIF
-!            END DO
-!         END DO
-!      END DO
-!clem@order
       ENDIF  ! ln_limdyn=.true.
       !
@@ -601,6 +523,5 @@
                DO ji = 1, jpi
                   !
-                  IF(  a_i(ji,jj,jl)    > epsi11  .AND.     &
-                       athorn(ji,jj,jl) > 0._wp   ) THEN
+                  IF( a_i(ji,jj,jl) > epsi10 .AND. athorn(ji,jj,jl) > 0._wp ) THEN
                      hi = v_i(ji,jj,jl) / a_i(ji,jj,jl)
                      !----------------------------
@@ -620,5 +541,5 @@
                         * z1_3 * (hrmax(ji,jj,jl)**3 - hrmin(ji,jj,jl)**3) / ( hrmax(ji,jj,jl)-hrmin(ji,jj,jl) )   
 !!gm Optimization:  (a**3-b**3)/(a-b) = a*a+ab+b*b   ==> less costly operations even if a**3 is replaced by a*a*a...                    
-                  ENDIF            ! aicen > epsi11
+                  ENDIF            ! aicen > epsi10
                   !
                END DO ! ji
@@ -677,5 +598,5 @@
          DO jj = 2, jpj - 1
             DO ji = 2, jpi - 1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi11) THEN ! ice is
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi10) THEN ! ice is
                   ! present
                   zworka(ji,jj) = 4.0 * strength(ji,jj)              &
@@ -717,5 +638,5 @@
          DO jj = 1, jpj - 1
             DO ji = 1, jpi - 1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi11) THEN       ! ice is present
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi10) THEN       ! ice is present
                   numts_rm = 1 ! number of time steps for the running mean
                   IF ( strp1(ji,jj) .GT. 0.0 ) numts_rm = numts_rm + 1
@@ -790,5 +711,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ato_i(ji,jj) > epsi11 ) THEN   ;   Gsum(ji,jj,0) = ato_i(ji,jj)
+            IF( ato_i(ji,jj) > epsi10 ) THEN   ;   Gsum(ji,jj,0) = ato_i(ji,jj)
             ELSE                               ;   Gsum(ji,jj,0) = 0._wp
             ENDIF
@@ -800,5 +721,5 @@
          DO jj = 1, jpj 
             DO ji = 1, jpi
-               IF( a_i(ji,jj,jl) .GT. epsi11 ) THEN   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1) + a_i(ji,jj,jl)
+               IF( a_i(ji,jj,jl) .GT. epsi10 ) THEN   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1) + a_i(ji,jj,jl)
                ELSE                                   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1)
                ENDIF
@@ -883,10 +804,9 @@
       IF ( raftswi == 1 ) THEN
 
-         IF( MAXVAL(aridge + araft - athorn(:,:,1:jpl)) .GT. epsi11 ) THEN
+         IF( MAXVAL(aridge + araft - athorn(:,:,1:jpl)) .GT. epsi10 ) THEN
             DO jl = 1, jpl
                DO jj = 1, jpj
                   DO ji = 1, jpi
-                     IF ( aridge(ji,jj,jl) + araft(ji,jj,jl) - athorn(ji,jj,jl) .GT. &
-                        epsi11 ) THEN
+                     IF ( aridge(ji,jj,jl) + araft(ji,jj,jl) - athorn(ji,jj,jl) .GT. epsi10 ) THEN
                         WRITE(numout,*) ' ALERTE 96 : wrong participation function ... '
                         WRITE(numout,*) ' ji, jj, jl : ', ji, jj, jl
@@ -934,5 +854,5 @@
             DO ji = 1, jpi
 
-               IF (a_i(ji,jj,jl) .GT. epsi11 .AND. athorn(ji,jj,jl) .GT. 0.0 ) THEN
+               IF (a_i(ji,jj,jl) .GT. epsi10 .AND. athorn(ji,jj,jl) .GT. 0.0 ) THEN
                   hi = v_i(ji,jj,jl) / a_i(ji,jj,jl)
                   hrmean          = MAX(SQRT(Hstar*hi), hi*krdgmin)
@@ -988,5 +908,5 @@
       INTEGER ::   ij                ! horizontal index, combines i and j loops
       INTEGER ::   icells            ! number of cells with aicen > puny
-      REAL(wp) ::   zeps, zindb, zsrdg2   ! local scalar
+      REAL(wp) ::   zindb, zsrdg2   ! local scalar
       REAL(wp) ::   hL, hR, farea, zdummy, zdummy0, ztmelts    ! left and right limits of integration
 
@@ -1040,11 +960,13 @@
 
       IF( con_i ) THEN
-         CALL lim_column_sum (jpl,   v_i, vice_init )
-         WRITE(numout,*) ' vice_init  : ', vice_init(jiindx,jjindx)
+         CALL lim_column_sum        (jpl,    v_i,       vice_init )
          CALL lim_column_sum_energy (jpl, nlay_i,  e_i, eice_init )
-         WRITE(numout,*) ' eice_init  : ', eice_init(jiindx,jjindx)
+         DO ji = mi0(jiindx), mi1(jiindx)
+            DO jj = mj0(jjindx), mj1(jjindx)
+               WRITE(numout,*) ' vice_init  : ', vice_init(ji,jj)
+               WRITE(numout,*) ' eice_init  : ', eice_init(ji,jj)
+            END DO
+         END DO
       ENDIF
-
-      zeps   = 1.e-20_wp
 
       !-------------------------------------------------------------------------------
@@ -1058,5 +980,5 @@
             ato_i(ji,jj) = ato_i(ji,jj) - athorn(ji,jj,0) * closing_gross(ji,jj) * rdt_ice        &
                &                        + opning(ji,jj)                          * rdt_ice
-            IF( ato_i(ji,jj) < -epsi11 ) THEN
+            IF( ato_i(ji,jj) < -epsi10 ) THEN
                neg_ato_i = .TRUE.
             ELSEIF( ato_i(ji,jj) < 0._wp ) THEN    ! roundoff error
@@ -1070,9 +992,9 @@
          DO jj = 1, jpj 
             DO ji = 1, jpi
-               IF( ato_i(ji,jj) < -epsi11 ) THEN 
+               IF( ato_i(ji,jj) < -epsi10 ) THEN 
                   WRITE(numout,*) ''  
                   WRITE(numout,*) 'Ridging error: ato_i < 0'
                   WRITE(numout,*) 'ato_i : ', ato_i(ji,jj)
-               ENDIF               ! ato_i < -epsi11
+               ENDIF               ! ato_i < -epsi10
             END DO
          END DO
@@ -1116,6 +1038,6 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF( aicen_init(ji,jj,jl1)  >  epsi11  .AND.  athorn(ji,jj,jl1)  >  0._wp       &
-                  .AND. closing_gross(ji,jj) > 0._wp ) THEN
+               IF( aicen_init(ji,jj,jl1) > epsi10 .AND. athorn(ji,jj,jl1) > 0._wp  &
+                  &   .AND. closing_gross(ji,jj) > 0._wp ) THEN
                   icells = icells + 1
                   indxi(icells) = ji
@@ -1154,10 +1076,10 @@
             afrft(ji,jj) = arft1(ji,jj) / aicen_init(ji,jj,jl1) !rafting
 
-            IF (afrac(ji,jj) > kamax + epsi11) THEN  !riging
+            IF (afrac(ji,jj) > kamax + epsi10) THEN  !riging
                large_afrac = .true.
             ELSEIF (afrac(ji,jj) > kamax) THEN  ! roundoff error
                afrac(ji,jj) = kamax
             ENDIF
-            IF (afrft(ji,jj) > kamax + epsi11) THEN !rafting
+            IF (afrft(ji,jj) > kamax + epsi10) THEN !rafting
                large_afrft = .true.
             ELSEIF (afrft(ji,jj) > kamax) THEN  ! roundoff error
@@ -1218,5 +1140,4 @@
             dardg1dt   (ji,jj) = dardg1dt(ji,jj) + ardg1(ji,jj) + arft1(ji,jj)
             dardg2dt   (ji,jj) = dardg2dt(ji,jj) + ardg2(ji,jj) + arft2(ji,jj)
-            !clem diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) * r1_rdtice
             opening    (ji,jj) = opening (ji,jj) + opning(ji,jj) * rdt_ice
 
@@ -1272,6 +1193,6 @@
 
                ! corrected sea water salinity
-               zindb  = MAX( 0._wp , SIGN( 1._wp , vsw(ji,jj) - zeps ) )
-               zdummy = zindb * ( srdg1(ji,jj) - srdg2(ji,jj) ) / MAX( ridge_por * vsw(ji,jj), zeps )
+               zindb  = MAX( 0._wp , SIGN( 1._wp , vsw(ji,jj) - epsi20 ) )
+               zdummy = zindb * ( srdg1(ji,jj) - srdg2(ji,jj) ) / MAX( ridge_por * vsw(ji,jj), epsi20 )
 
                ztmelts          = - tmut * zdummy + rtt
@@ -1308,5 +1229,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrac(ji,jj) > kamax + epsi11 ) THEN 
+               IF( afrac(ji,jj) > kamax + epsi10 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' ardg > a_i'
@@ -1320,5 +1241,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrft(ji,jj) > kamax + epsi11 ) THEN 
+               IF( afrft(ji,jj) > kamax + epsi10 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' arft > a_i'
@@ -1420,12 +1341,17 @@
          fieldid = ' v_i : limitd_me '
          CALL lim_cons_check (vice_init, vice_final, 1.0e-6, fieldid) 
-         WRITE(numout,*) ' vice_init  : ', vice_init(jiindx,jjindx)
-         WRITE(numout,*) ' vice_final : ', vice_final(jiindx,jjindx)
 
          CALL lim_column_sum_energy (jpl, nlay_i,  e_i, eice_final )
          fieldid = ' e_i : limitd_me '
          CALL lim_cons_check (eice_init, eice_final, 1.0e-2, fieldid) 
-         WRITE(numout,*) ' eice_init  : ', eice_init(jiindx,jjindx)
-         WRITE(numout,*) ' eice_final : ', eice_final(jiindx,jjindx)
+
+         DO ji = mi0(jiindx), mi1(jiindx)
+            DO jj = mj0(jjindx), mj1(jjindx)
+               WRITE(numout,*) ' vice_init  : ', vice_init (ji,jj)
+               WRITE(numout,*) ' vice_final : ', vice_final(ji,jj)
+               WRITE(numout,*) ' eice_init  : ', eice_init (ji,jj)
+               WRITE(numout,*) ' eice_final : ', eice_final(ji,jj)
+            END DO
+         END DO
       ENDIF
       !
@@ -1536,5 +1462,5 @@
 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zmask   ! 2D workspace
-      
+      REAL(wp)                          ::   zmask_glo
 !!gm      REAL(wp) ::   xtmp      ! temporary variable
       !!-------------------------------------------------------------------
@@ -1548,27 +1474,16 @@
          ! Abort model in case of negative area.
          !-----------------------------------------------------------------
-         IF( MINVAL(a_i(:,:,jl)) .LT. -epsi11 .AND. ln_nicep ) THEN
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF ( a_i(ji,jj,jl) .LT. -epsi11 ) THEN
-                     WRITE (numout,*) ' ALERTE 98 ' 
-                     WRITE (numout,*) ' Negative ice area: ji, jj, jl: ', ji, jj,jl
-                     WRITE (numout,*) ' a_i    ', a_i(ji,jj,jl)
-                  ENDIF
-               END DO
-            END DO
-         ENDIF
-
          icells = 0
-         zmask  = 0._wp
+         zmask(:,:)  = 0._wp
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF(  ( a_i(ji,jj,jl) .GE. -epsi11 .AND. a_i(ji,jj,jl) .LT. 0._wp   ) .OR.   &
-                  & ( a_i(ji,jj,jl) .GT. 0._wp   .AND. a_i(ji,jj,jl) .LE. 1.0e-11 ) .OR.   &
-                  & ( v_i(ji,jj,jl)  ==  0._wp   .AND. a_i(ji,jj,jl) .GT. 0._wp   ) .OR.   &
-                  & ( v_i(ji,jj,jl) .GT. 0._wp   .AND. v_i(ji,jj,jl) .LT. 1.e-12  )      )   zmask(ji,jj) = 1._wp
-            END DO
-         END DO
-         IF( ln_nicep )   WRITE(numout,*) SUM(zmask), ' cells of ice zapped in the ocean '
+               IF(  ( a_i(ji,jj,jl) >= -epsi10 .AND. a_i(ji,jj,jl) <  0._wp   ) .OR.   &
+                  & ( a_i(ji,jj,jl) >  0._wp   .AND. a_i(ji,jj,jl) <= epsi10  ) .OR.   &
+                  & ( v_i(ji,jj,jl) == 0._wp   .AND. a_i(ji,jj,jl) >  0._wp   ) .OR.   &
+                  & ( v_i(ji,jj,jl) >  0._wp   .AND. v_i(ji,jj,jl) <= epsi10  ) )   zmask(ji,jj) = 1._wp
+            END DO
+         END DO
+         zmask_glo = glob_sum(zmask)
+         !IF( ln_nicep .AND. lwp ) WRITE(numout,*) zmask_glo, ' cells of ice zapped in the ocean '
 
          !-----------------------------------------------------------------
@@ -1582,5 +1497,5 @@
 !!gm                  xtmp = xtmp * unit_fac
                   ! fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * ( 1 - zmask(ji,jj) )
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * ( 1._wp - zmask(ji,jj) )
                END DO
             END DO
@@ -1604,5 +1519,5 @@
 !!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice !RB   ???????
 
-               t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1 - zmask(ji,jj) )
+               t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1._wp - zmask(ji,jj) )
 
                !-----------------------------------------------------------------
@@ -1618,10 +1533,10 @@
 
                ato_i(ji,jj)    = a_i  (ji,jj,jl) *       zmask(ji,jj)   + ato_i(ji,jj)
-               a_i  (ji,jj,jl) = a_i  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               v_i  (ji,jj,jl) = v_i  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               v_s  (ji,jj,jl) = v_s  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               t_su (ji,jj,jl) = t_su (ji,jj,jl) * ( 1 - zmask(ji,jj) ) + t_bo(ji,jj) * zmask(ji,jj)
-               oa_i (ji,jj,jl) = oa_i (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               smv_i(ji,jj,jl) = smv_i(ji,jj,jl) * ( 1 - zmask(ji,jj) )
+               a_i  (ji,jj,jl) = a_i  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               v_i  (ji,jj,jl) = v_i  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               v_s  (ji,jj,jl) = v_s  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               t_su (ji,jj,jl) = t_su (ji,jj,jl) * ( 1._wp - zmask(ji,jj) ) + t_bo(ji,jj) * zmask(ji,jj)
+               oa_i (ji,jj,jl) = oa_i (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               smv_i(ji,jj,jl) = smv_i(ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
                !
             END DO
